import alice.tucson.api.*;
import alice.logictuple.*;
import javax.swing.*;


/**
 * Questa classe implementa un agente TuCSoN incaricato di interrompere la simulazione
 */
public class AgenteAntiSimulatore extends Agent {
	
	protected TupleCentreId semaforo;
	protected TupleCentreId rotonda;
	

/**
 * Inizializza il contesto e il centro di tuple.
 */
	public AgenteAntiSimulatore(String aid) throws Exception {
		super(new AgentId(aid));
		semaforo = new TupleCentreId ("semaforo");
		rotonda = new TupleCentreId ("rotonda");		
	}


/**
 * Commuta la stato della simulazione da 'start' a 'wait';
 * mostra una finestra che invita ad attendere la fine della simulazione;
 * aspetta che sia la rotonda che il semaforo non abbiano pi utenti;
 * commuta lo stato della simulazione da 'wait' a 'stop'.
 */
	protected void body() {
		try {
			out (semaforo, new LogicTuple("set_stato", new Value("wait")));
			out (rotonda, new LogicTuple("set_stato", new Value("wait")));

			JWindow w = new JWindow();
			w.setBounds(200, 260, 200, 100);
			w.setBackground(java.awt.Color.WHITE);
			w.getContentPane().add(new JTextArea("\n    Smaltimento del traffico residuo in corso...    \n"));
			w.pack();
			w.setVisible(true);
			
			rd (rotonda, new LogicTuple("utenti", new Value("totale"), new Value(0)));
			out (rotonda, new LogicTuple("set_stato", new Value("stop")));

			rd (semaforo, new LogicTuple("utenti", new Value("totale"), new Value(0)));
			out (semaforo, new LogicTuple("set_stato", new Value("stop")));
			
			w.setVisible(false);
		} catch (Exception ex) {
			ex.printStackTrace ();
		}
	}
}
