import alice.tucson.api.*;
import alice.logictuple.*;


/**
 * Questa classe implementa un agente utilizzato solo nel caso in cui si scelga
 * di interrompere la simulazione dopo un determinato numero di agenti.
 * E' un agente TuCSoN
 */
public class AgenteStopAutomatico extends Agent {

	protected TupleCentreId semaforo;

/**
 * Numero di agenti che devono essere lanciati
 */
	protected int nAgents;
	protected Interfaccia gui;


/**
 * Inizializza il contesto e il centro di tuple e le altre variabili.
 */
	public AgenteStopAutomatico (String aid, int n, Interfaccia i) throws Exception {
		super(new AgentId(aid));
		semaforo = new TupleCentreId ("semaforo");
		nAgents = n;
		gui = i;
	}
	
	
	
/**
 * Legge nell'ambiente TuCSoN quanti agenti sono stati lanciati, quando tale numero
 *  pari a quello impostato dall'utente (nAgents) allora lancia l'agente
 * anti simulatore che blocca la simulazione.
 */
	protected void body() {
		try {
			AgenteAntiSimulatore aas = new AgenteAntiSimulatore ("stop");
			rd (semaforo, new LogicTuple("statistiche", new Value("utenti_arrivati"), new Value(nAgents)));
			aas.spawn ();
       		gui.stopConfiguration();
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}
