import java.awt.*;
import javax.swing.*;


/**
 * Classe che implementa il componente utilizzato per mostrare le statistiche
 */
public class Report {
	
	protected JFrame frame;
	protected JTextArea outputDevice;
	

/**
 * Costruisce la finestra senza renderla visibile
 */
	public Report() {
		frame = new JFrame("Risultati");
		frame.setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
        Container container = frame.getContentPane();
        outputDevice = new JTextArea();
        outputDevice.setEditable(false);
		container.add (outputDevice);

        frame.setBounds(350, 0, 260, 250);
		frame.setVisible (false);
	}
	
	
/**
 * Mostra la finestra
 */
	public void setVisible (boolean b) {
		frame.setVisible(b);
	}
	

/**
 * Modifica la visibilit della finestra
 */
	public void toggleVisibility () {
		frame.setVisible(!frame.isVisible());
	}
	

/**
 * Stampa le statistiche ricevute
 */
	public void print (Statistics s) {
		outputDevice.setText(s.toString());
	}
}
