
/**
 * Componente che contiene tutte le statistiche ottenute dalla simulazione.
 * Prevede un metodo (toString()) per convertirle in testo.
 */
public class Statistics {

/**
 * Somma di tutti i tempi di interarrivo
 */
	protected long totalArrivalTime;


/**
 * Agenti lanciati
 */
	protected long arrivedUser;


/**
 * Somma di tutti i tempi di servizio per il semaforo
 */
	protected long totalServiceTimeSmf;


/**
 * Utenti serviti al semaforo
 */
	protected long servedUserSmf;


/**
 * Somma di tutti i tempi di servizio per la rotonda
 */
	protected long totalServiceTimeRtd;


/**
 * Utenti serviti alla rotonda
 */
	protected long servedUserRtd;


/**
 * Coda massima al semaforo
 */
	protected long maxQueueSmf;


/**
 * Coda massima alla rotonda
 */
	protected long maxQueueRtd;
	

/**
 * sim_time millisecondi del simulatore corrispondono ad 1 secondo reale.
 * All'aumentare di SIM_TIME diminuisce la velocit del simulatore.
 */	
	protected int sim_time;
	
	
/**
 * Inizializza tutte le variabili
 */
	public Statistics(int t) {
		totalArrivalTime = 0;
		arrivedUser = 0;
		totalServiceTimeSmf = 0;
		servedUserSmf = 0;
		totalServiceTimeRtd = 0;
		servedUserRtd = 0;
		maxQueueSmf = 0;
		maxQueueRtd = 0;
		
		sim_time = t;
	}
	
	
	public void setTotalArrivalTime (long t) { totalArrivalTime = t; }
	public long getTotalArrivalTime () { return totalArrivalTime; }
	
	public void setArrivedUser (long u) { arrivedUser = u; }
	public long getArrivedUser () { return arrivedUser; }
	
	public void setTotalServiceTimeSmf (long t) { totalServiceTimeSmf = t; }
	public long getTotalServiceTimeSmf () { return totalServiceTimeSmf; }
	
	public void setServedUserSmf (long u) { servedUserSmf = u; }
	public long getServedUserSmf () { return servedUserSmf; }

	public void setTotalServiceTimeRtd (long t) { totalServiceTimeRtd = t; }
	public long getTotalServiceTimeRtd () { return totalServiceTimeRtd; }
	
	public void setServedUserRtd (long u) { servedUserRtd = u; }
	public long getServedUserRtd () { return servedUserRtd; }
	
	public void setMaxQueueSmf(long q) { maxQueueSmf = q; }
	public long getMaxQueueSmf(long q) { return maxQueueSmf; }

	public void setMaxQueueRtd(long q) { maxQueueRtd = q; }
	public long getMaxQueueRtd(long q) { return maxQueueRtd; }



/**
 * Converte le statistiche in un dato di tipo String
 */
	public String toString() {
		long sus = 1;
		long sur = 1;
		long au = 1;
		if (servedUserSmf != 0) sus = servedUserSmf; 
		if (servedUserRtd != 0) sur = servedUserRtd; 
		if (arrivedUser != 0) au = arrivedUser; 
		return 
		"  --- STATISTICHE DEGLI ARRIVI ---\n" + 
		" Utenti arrivati: " + arrivedUser + "\n" +
		" Tempo medio di interarrivo: " + ((float)(totalArrivalTime/au))/sim_time + " secondi\n\n" +
		"  --- STATISTICHE DEL SEMAFORO --- \n" + 
		" Utenti serviti: " + servedUserSmf + "\n" +
		" Tempo medio di servizio: " + ((float)(totalServiceTimeSmf/sus))/sim_time + " secondi\n" +
		" Fila pi lunga: " + maxQueueSmf + " utenti\n\n" + 
		"  --- STATISTICHE DELLA ROTONDA --- \n" + 
		" Utenti serviti: " + servedUserRtd + "\n" +
		" Tempo medio di servizio: " + ((float)(totalServiceTimeRtd/sur))/sim_time + " secondi\n" + 
		" Fila pi lunga: " + maxQueueRtd + " utenti\n";
	}
}
